/*
 * 首页快捷入口
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class IndexIconListController : BaseController
    {
        public IndexIconListController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 首页快捷入口列表

        /// <summary>
        /// 根据条件查询首页快捷入口列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(IndexIconList data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询首页快捷入口列表

        /// <summary>
        /// 首页快捷入口列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(IndexIconList data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("Title", "1"); //标题
            Fields.Add("Url", "1"); //跳转地址


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("IndexIconList", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }
            return Json(obj);
        }

        #endregion

        #region 增加首页快捷入口

        /// <summary>
        /// 增加或修改首页快捷入口信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加首页快捷入口

        /// <summary>
        /// 增加或修改首页快捷入口信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(IndexIconList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Icon", data.Icon); //图标
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Url", data.Url); //跳转地址

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("IndexIconList", Fields, 0);
            AddSysLog(data.Id.ToString(), "IndexIconList", "add");
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 修改首页快捷入口

        /// <summary>
        /// 增加或修改首页快捷入口信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            IndexIconList editData = db.IndexIconList.FirstOrDefault(m => m.Id == Id) ?? new IndexIconList();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改首页快捷入口

        /// <summary>
        /// 增加或修改首页快捷入口信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(IndexIconList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("Icon", data.Icon); //图标
            Fields.Add("Title", data.Title); //标题
            Fields.Add("Url", data.Url); //跳转地址

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("IndexIconList", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "IndexIconList", "update");
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 删除首页快捷入口信息

        /// <summary>
        /// 删除首页快捷入口信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "IndexIconList", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("IndexIconList", Fields, id);
            }
            db.SaveChanges();

            SetRedis();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "IndexIconList", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("IndexIconList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "IndexIconList", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("IndexIconList", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("IndexIconList", Sort, Id);

            AddSysLog(Id.ToString(), "IndexIconList", "sort");

            SetRedis();
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.IndexIconList.Add(new IndexIconList()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "IndexIconList", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(IndexIconList data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Title", "1"); //标题
            Fields.Add("Url", "1"); //跳转地址


            string condition = " and Status>-1";


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("IndexIconList", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "IndexIconList", "ExportExcel");
            return Json(result);
        }

        #endregion




        #region 设置缓存

        private void SetRedis()
        {
            List<IndexIconList> query = db.IndexIconList.Where(m => m.Status > -1).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
            RedisDbconn.Instance.Clear("IndexIconList");
            RedisDbconn.Instance.AddList("IndexIconList", query.ToArray());
            AddSysLog("0", "IndexIconList", "SetRedis");
        }

        #endregion

    }
}
